#ifndef PREC_Z_H
#define PREC_Z_H

#ifdef PREC_Z
	// host
	#define MUBLAS_GEMM mublasZgemm
	#define MUBLAS_GEMV mublasZgemv
	#define MUBLAS_AXPY mublasZaxpy
	#define MUBLAS_SCAL mublasZscal
	#define MUBLAS_COPY mublasZcopy
	#define CUBLAS_GEMM cublasZgemm
	#define CUBLAS_GEMV cublasZgemv
	#define CUBLAS_AXPY cublasZaxpy
	#define CUBLAS_SCAL cublasZscal
	#define CUBLAS_COPY cublasZcopy
	#define TYPE0 cuDoubleComplex
	#define ZERO0 make_cuDoubleComplex(0.,0.)
	#define ONE0 make_cuDoubleComplex(1.,0.)

	// vec1
	#define VEC1 1
	#define TYPE1 TYPE0
	#define ZERO1 ZERO0
	#define ADD1 cuCadd
	#define MUL1 cuCmul
	#define MAD1 cuCmad

	#define TYPEIN1 TYPE1
	#define ZEROIN1 ZERO1
	#define LOAD1 
	#define STORE1 
	#define MAD_1_111 MAD1
	#define MAD_1_111 MAD1
	#define MUL_1_11 MUL1

	// vec2
	#define VEC2 0

	// vec4
	#define VEC4 0
#endif

// === Shuffle =====================================================
__device__ __forceinline__ void shuffleAdd (cuDoubleComplex &val, const int n) {
#if defined (__CUDA_ARCH__) && (__CUDA_ARCH__ >= 300)
	val = cuCadd (val, make_cuDoubleComplex ( 
		__hiloint2double( __shfl_xor(__double2hiint(val.x), n, T_W), __shfl_xor(__double2loint(val.x), n, T_W)),
		__hiloint2double( __shfl_xor(__double2hiint(val.y), n, T_W), __shfl_xor(__double2loint(val.y), n, T_W))));
#endif
}
// === Shuffle =====================================================


__host__ __device__ __forceinline__ bool operator== (const cuDoubleComplex a, const cuDoubleComplex b) {
	if ((a.x == b.x) && (a.y == b.y))
		return true;
	else
		return false;
}

__device__ __forceinline__ cuDoubleComplex
cuCmad
	(const cuDoubleComplex a, const cuDoubleComplex b, const cuDoubleComplex c)
{
	return cuCadd(cuCmul(a, b), c);
}

#endif
