#ifndef PREC_C_H
#define PREC_C_H

#ifdef PREC_C

#define FPADDCOUNT 2
#define FPMULCOUNT 6
#define FPMADCOUNT 8

// TYPE
#define CBLAS_TYPE complex
#define CBLAS_BASETYPE float
#define MBLAS_TYPE qd_complex
#define MBLAS_BASETYPE qd_real
#define CBLAS_ZERO {0.,0.}
#define CBLAS_ONE {1.,0.}
#define CBLAS_NEGONE {-1.,0.}
#define MBLAS_ZERO qd_complex(qd_real(0.),qd_real(0.))
#define MBLAS_ONE qd_complex(qd_real(1.),qd_real(0.))
#define MBLAS_NEGONE qd_complex(qd_real(-1.),qd_real(0.))

#if defined (MUBLAS)
#define GPU_TYPE cuFloatComplex
#elif defined (CUBLAS)
#define GPU_TYPE cuFloatComplex
#elif defined (KBLAS)
#define GPU_TYPE cuFloatComplex
#elif defined (MAGMA)
#define GPU_TYPE magmaFloatComplex
#elif defined (CULA)
#define GPU_TYPE culaFloatComplex
#elif defined (ASPEN)
#define GPU_TYPE cuFloatComplex
#endif
#define MAKE_GPU_TYPE(r,i) make_cuFloatComplex(r,i)

// COPY
#define CBLAS_COPY cblas_ccopy
#define MBLAS_COPY Ccopy
#define MUBLAS_COPY mublasCcopy
#define CUBLAS_COPY cublasCcopy
#define MAGMA_COPY magmablas_ccopy
#define CULA_COPY culaDeviceCcopy
#define KBLAS_COPY kblas_ccopy

// SCAL
#define CBLAS_SCAL cblas_cscal
#define MBLAS_SCAL Cscal
#define MUBLAS_SCAL mublasCscal
#define CUBLAS_SCAL cublasCscal
#define MAGMA_SCAL 
#define CULA_SCAL 
#define KBLAS_SCAL

// AXPY
#define CBLAS_AXPY cblas_caxpy
#define MBLAS_AXPY Caxpy
#define MUBLAS_AXPY mublasCaxpy
#define CUBLAS_AXPY cublasCaxpy
#define MAGMA_AXPY magmablas_caxpy
#define CULA_AXPY culaDeviceCaxpy
#define KBLAS_AXPY kblas_caxpy

// GEMV
#define CBLAS_GEMV cblas_cgemv
#define MBLAS_GEMV Cgemv
#define MUBLAS_GEMV mublasCgemv
#define CUBLAS_GEMV cublasCgemv
#define MAGMA_GEMV magmablas_cgemv
#define CULA_GEMV culaDeviceCgemv
#define KBLAS_GEMV kblas_cgemv
#define ASPEN_GEMV ASPEN_cgemv

// HEMV
#define CBLAS_HEMV cblas_chemv
#define MBLAS_HEMV Chemv
#define MUBLAS_HEMV
#define CUBLAS_HEMV cublasChemv
#define MAGMA_HEMV magmablas_chemv
#define CULA_HEMV culaDeviceChemv
#define KBLAS_HEMV kblas_chemv
#define ASPEN_HEMV ASPEN_chemv

// TRMV
#define CBLAS_TRMV cblas_ctrmv
#define MBLAS_TRMV Ctrmv
#define MUBLAS_TRMV
#define CUBLAS_TRMV cublasCtrmv
#define MAGMA_TRMV magmablas_ctrmv
#define CULA_TRMV culaDeviceCtrmv
#define KBLAS_TRMV
#define ASPEN_TRMV

// GEMM
#define CBLAS_GEMM cblas_cgemm
#define MBLAS_GEMM Cgemm
#define MUBLAS_GEMM mublasCgemm
#define CUBLAS_GEMM cublasCgemm
#define MAGMA_GEMM magmablas_cgemm
#define CULA_GEMM culaDeviceCgemm
#define KBLAS_GEMM 
#define ASPEN_GEMM 

// NRM2
#define CBLAS_NRM cblas_scnrm2
#define MBLAS_NRM RCnrm2

#endif

#endif
