#ifndef PREC_V_H
#define PREC_V_H

#ifdef PREC_V

#define FPADDCOUNT 2
#define FPMULCOUNT 6
#define FPMADCOUNT 8

// TYPE
#define CBLAS_TYPE doublecomplex
#define CBLAS_BASETYPE double
#define MBLAS_TYPE qd_complex
#define MBLAS_BASETYPE qd_real
#define CBLAS_ZERO {0.,0.}
#define CBLAS_ONE {1.,0.}
#define CBLAS_NEGONE {-1.,0.}
#define MBLAS_ZERO qd_complex(qd_real(0.),qd_real(0.))
#define MBLAS_ONE qd_complex(qd_real(1.),qd_real(0.))
#define MBLAS_NEGONE qd_complex(qd_real(-1.),qd_real(0.))

#if defined (MUBLAS)
#define GPU_TYPE cudfcomplex
#elif defined (CUBLAS)
#define GPU_TYPE 
#elif defined (KBLAS)
#define GPU_TYPE
#elif defined (MAGMA)
#define GPU_TYPE
#elif defined (CULA)
#define GPU_TYPE
#elif defined (ASPEN)
#define GPU_TYPE cudfcomplex
#endif
#define MAKE_GPU_TYPE(r,i) make_cudfcomplex(double_to_cudfreal(r),double_to_cudfreal(i))

// COPY
#define CBLAS_COPY cblas_zcopy
#define MBLAS_COPY Ccopy
#define MUBLAS_COPY mublasVcopy
#define CUBLAS_COPY 
#define MAGMA_COPY
#define CULA_COPY
#define KBLAS_COPY

// SCAL
#define CBLAS_SCAL cblas_zscal
#define MBLAS_SCAL Cscal
#define MUBLAS_SCAL mublasVscal
#define CUBLAS_SCAL 
#define MAGMA_SCAL 
#define CULA_SCAL 
#define KBLAS_SCAL

// AXPY
#define CBLAS_AXPY cblas_zaxpy
#define MBLAS_AXPY Caxpy
#define MUBLAS_AXPY mublasVaxpy
#define CUBLAS_AXPY 
#define MAGMA_AXPY
#define CULA_AXPY
#define KBLAS_AXPY

// GEMV
#define CBLAS_GEMV cblas_zgemv
#define MBLAS_GEMV Cgemv
#define MUBLAS_GEMV mublasVgemv
#define CUBLAS_GEMV 
#define MAGMA_GEMV
#define CULA_GEMV
#define KBLAS_GEMV
#define ASPEN_GEMV ASPEN_vgemv

// HEMV
#define CBLAS_HEMV cblas_zhemv
#define MBLAS_HEMV Chemv
#define ASPEN_HEMV ASPEN_vhemv

// GEMM
#define CBLAS_GEMM cblas_zgemm
#define MBLAS_GEMM Cgemm
#define MUBLAS_GEMM mublasVgemm
#define CUBLAS_GEMM
#define MAGMA_GEMM
#define CULA_GEMM
#define KBLAS_GEMM 
#define ASPEN_GEMM 

// NRM2
#define CBLAS_NRM cblas_dznrm2
#define MBLAS_NRM RCnrm2

#endif

#endif
