#ifndef PREC_W_H
#define PREC_W_H

#ifdef PREC_W

#define FPADDCOUNT 1
#define FPMULCOUNT 1
#define FPMADCOUNT 2

// TYPE
#define CBLAS_TYPE double
#define CBLAS_BASETYPE CBLAS_TYPE
#define MBLAS_TYPE qd_real
#define MBLAS_BASETYPE MBLAS_TYPE
#define CBLAS_ZERO 0.
#define CBLAS_ONE 1.
#define CBLAS_NEGONE -1.
#define MBLAS_ZERO qd_real(0.)
#define MBLAS_ONE qd_real(1.)
#define MBLAS_NEGONE qd_real(-1.)

#if defined (MUBLAS)
#define GPU_TYPE cuddreal
#elif defined (CUBLAS)
#define GPU_TYPE 
#elif defined (KBLAS)
#define GPU_TYPE
#elif defined (MAGMA)
#define GPU_TYPE
#elif defined (CULA)
#define GPU_TYPE
#elif defined (ASPEN)
#define GPU_TYPE cuddreal
#endif
#define MAKE_GPU_TYPE(x) make_cuddreal(x)

// COPY
#define CBLAS_COPY cblas_dcopy
#define MBLAS_COPY Rcopy
#define MUBLAS_COPY mublasWcopy
#define CUBLAS_COPY 
#define MAGMA_COPY 
#define CULA_COPY
#define KBLAS_COPY 

// SCAL
#define CBLAS_SCAL cblas_dscal
#define MBLAS_SCAL Rscal
#define MUBLAS_SCAL mublasWscal
#define CUBLAS_SCAL 
#define MAGMA_SCAL 
#define CULA_SCAL
#define KBLAS_SCAL 

// AXPY
#define CBLAS_AXPY cblas_daxpy
#define MBLAS_AXPY Raxpy
#define MUBLAS_AXPY mublasWaxpy
#define CUBLAS_AXPY 
#define MAGMA_AXPY 
#define CULA_AXPY
#define KBLAS_AXPY 

// GEMV
#define CBLAS_GEMV cblas_dgemv
#define MBLAS_GEMV Rgemv
#define MUBLAS_GEMV mublasWgemv
#define CUBLAS_GEMV 
#define MAGMA_GEMV 
#define CULA_GEMV
#define KBLAS_GEMV 
#define ASPEN_GEMV ASPEN_wgemv

// SYMV
#define CBLAS_SYMV cblas_dsymv
#define MBLAS_SYMV Rsymv
#define ASPEN_SYMV ASPEN_wsymv

// GEMM
#define CBLAS_GEMM cblas_dgemm
#define MBLAS_GEMM Rgemm
#define MUBLAS_GEMM mublasWgemm
#define CUBLAS_GEMM
#define MAGMA_GEMM
#define CULA_GEMM
#define KBLAS_GEMM 
#define ASPEN_GEMM 

// NRM2
#define CBLAS_NRM cblas_dnrm2
#define MBLAS_NRM Rnrm2

#endif

#endif
