#ifndef PREC_Z_H
#define PREC_Z_H

#ifdef PREC_Z

#define FPADDCOUNT 2
#define FPMULCOUNT 6
#define FPMADCOUNT 8

// TYPE
#define CBLAS_TYPE doublecomplex
#define CBLAS_BASETYPE double
#define MBLAS_TYPE qd_complex
#define MBLAS_BASETYPE qd_real
#define CBLAS_ZERO {0.,0.}
#define CBLAS_ONE {1.,0.}
#define CBLAS_NEGONE {-1.,0.}
#define MBLAS_ZERO qd_complex(qd_real(0.),qd_real(0.))
#define MBLAS_ONE qd_complex(qd_real(1.),qd_real(0.))
#define MBLAS_NEGONE qd_complex(qd_real(-1.),qd_real(0.))

#if defined (MUBLAS)
#define GPU_TYPE cuDoubleComplex
#elif defined (CUBLAS)
#define GPU_TYPE cuDoubleComplex
#elif defined (KBLAS)
#define GPU_TYPE cuDoubleComplex
#elif defined (MAGMA)
#define GPU_TYPE magmaDoubleComplex
#elif defined (CULA)
#define GPU_TYPE culaDoubleComplex
#elif defined (ASPEN)
#define GPU_TYPE cuDoubleComplex
#endif
#define MAKE_GPU_TYPE(r,i) make_cuDoubleComplex(r,i)

// COPY
#define CBLAS_COPY cblas_zcopy
#define MBLAS_COPY Ccopy
#define MUBLAS_COPY mublasZcopy
#define CUBLAS_COPY cublasZcopy
#define MAGMA_COPY magmablas_zcopy
#define CULA_COPY culaDeviceZcopy
#define KBLAS_COPY kblas_zcopy

// SCAL
#define CBLAS_SCAL cblas_zscal
#define MBLAS_SCAL Cscal
#define MUBLAS_SCAL mublasZscal
#define CUBLAS_SCAL cublasZscal
#define MAGMA_SCAL 
#define CULA_SCAL 
#define KBLAS_SCAL

// AXPY
#define CBLAS_AXPY cblas_zaxpy
#define MBLAS_AXPY Caxpy
#define MUBLAS_AXPY mublasZaxpy
#define CUBLAS_AXPY cublasZaxpy
#define MAGMA_AXPY magmablas_zaxpy
#define CULA_AXPY culaDeviceZaxpy
#define KBLAS_AXPY kblas_zaxpy

// GEMV
#define CBLAS_GEMV cblas_zgemv
#define MBLAS_GEMV Cgemv
#define MUBLAS_GEMV mublasZgemv
#define CUBLAS_GEMV cublasZgemv
#define MAGMA_GEMV magmablas_zgemv
#define CULA_GEMV culaDeviceZgemv
#define KBLAS_GEMV kblas_zgemv
#define ASPEN_GEMV ASPEN_zgemv

// HEMV
#define CBLAS_HEMV cblas_zhemv
#define MBLAS_HEMV Chemv
#define MUBLAS_HEMV
#define CUBLAS_HEMV cublasZhemv
#define MAGMA_HEMV magmablas_zhemv
#define CULA_HEMV culaDeviceZhemv
#define KBLAS_HEMV kblas_zhemv
#define ASPEN_HEMV ASPEN_zhemv

// TRMV
#define CBLAS_TRMV cblas_ztrmv
#define MBLAS_TRMV Ctrmv
#define MUBLAS_TRMV
#define CUBLAS_TRMV cublasZtrmv
#define MAGMA_TRMV magmablas_ztrmv
#define CULA_TRMV culaDeviceZtrmv
#define KBLAS_TRMV
#define ASPEN_TRMV

// GEMM
#define CBLAS_GEMM cblas_zgemm
#define MBLAS_GEMM Cgemm
#define MUBLAS_GEMM mublasZgemm
#define CUBLAS_GEMM cublasZgemm
#define MAGMA_GEMM magmablas_zgemm
#define CULA_GEMM culaDeviceZgemm
#define KBLAS_GEMM 
#define ASPEN_GEMM 

// NRM2
#define CBLAS_NRM cblas_dznrm2
#define MBLAS_NRM RCnrm2

#endif

#endif
